#include <jo/jo.h>
#include "Player.h"
#include "Collision.h"
#include "Display.h"

#define width (56)  //High value to prevent polygon clipping
#define width2 (28)
#define height (60)
#define height2 (30)
#define crouchingheight (20)
#define crouchingincrease (1)

_player player;


unsigned int Slopes[20][200];
grids map_BB[1000];  //Static array ATM
unsigned int map_total_BB;
#include "MESHES/LVL_BB.h"


/***********
Temporary solution until I improve the slopes detection, after I will just load everything
with the map binary file
***********/
void load_map_BB(unsigned int currentLvl)
{
    unsigned int i = 0;
    int ii=0;
    if (currentLvl == 1)
    {
        map_total_BB=sizeof(zone_bb)/sizeof(grids);
        for (i=0; i<map_total_BB; i++)
        {
            map_BB[i].PointX = zone_bb[i].PointX; map_BB[i].PointY = zone_bb[i].PointY; map_BB[i].PointZ = zone_bb[i].PointZ;
            map_BB[i].LengthX = zone_bb[i].LengthX; map_BB[i].LengthY = zone_bb[i].LengthY; map_BB[i].LengthZ = zone_bb[i].LengthZ;
            map_BB[i].Mask = zone_bb[i].Mask; map_BB[i].SlopeRXAngle = zone_bb[i].SlopeRXAngle; map_BB[i].SlopeRZAngle = zone_bb[i].SlopeRZAngle;
        }
        for (i=0; i<(sizeof(zone1_slopes)/(sizeof(unsigned int)*200)); i++)
        {
            for (ii=0; ii<200; ii++)
            {
               Slopes[i][ii] = zone1_slopes[i][ii];
            }
        }
        for (i=0; i< (sizeof(zone1_BSP)/(sizeof(unsigned int)*2)); i++)
        {
            BSP_BB[i].BB_start = zone1_BSP[i][0];
            BSP_BB[i].BB_end = zone1_BSP[i][1];
        }
    }
    else if (currentLvl==2)
    {
        map_total_BB=sizeof(zone2_bb)/sizeof(grids);
        for (i=0; i<map_total_BB; i++)
        {
            map_BB[i].PointX = zone2_bb[i].PointX; map_BB[i].PointY = zone2_bb[i].PointY; map_BB[i].PointZ = zone2_bb[i].PointZ;
            map_BB[i].LengthX = zone2_bb[i].LengthX; map_BB[i].LengthY = zone2_bb[i].LengthY; map_BB[i].LengthZ = zone2_bb[i].LengthZ;
            map_BB[i].Mask = zone2_bb[i].Mask; map_BB[i].SlopeRXAngle = zone2_bb[i].SlopeRXAngle; map_BB[i].SlopeRZAngle = zone2_bb[i].SlopeRZAngle;
        }

        for (i=0; i<(sizeof(zone2_slopes)/(sizeof(unsigned int)*200)); i++)
        {
            for (ii=0; ii<200; ii++)
            {
               Slopes[i][ii] = zone2_slopes[i][ii];
            }
        }
        for (i=0; i< (sizeof(zone2_BSP)/(sizeof(unsigned int)*2)); i++)
        {
            BSP_BB[i].BB_start = zone2_BSP[i][0];
            BSP_BB[i].BB_end = zone2_BSP[i][1];
        }
    }

    else if (currentLvl==3)
    {
        map_total_BB=sizeof(zone3_bb)/sizeof(grids);
        for (i=0; i<map_total_BB; i++)
        {
            map_BB[i].PointX = zone3_bb[i].PointX; map_BB[i].PointY = zone3_bb[i].PointY; map_BB[i].PointZ = zone3_bb[i].PointZ;
            map_BB[i].LengthX = zone3_bb[i].LengthX; map_BB[i].LengthY = zone3_bb[i].LengthY; map_BB[i].LengthZ = zone3_bb[i].LengthZ;
            map_BB[i].Mask = zone3_bb[i].Mask; map_BB[i].SlopeRXAngle = zone3_bb[i].SlopeRXAngle; map_BB[i].SlopeRZAngle = zone3_bb[i].SlopeRZAngle;
        }
        for (i=0; i<(sizeof(zone3_slopes)/(sizeof(unsigned int)*200)); i++)
        {
            for (ii=0; ii<200; ii++)
            {
                Slopes[i][ii] = zone3_slopes[i][ii];
            }
        }
        for (i=0; i< (sizeof(zone3_BSP)/(sizeof(unsigned int)*2)); i++)
        {
            BSP_BB[i].BB_start = zone3_BSP[i][0];
            BSP_BB[i].BB_end = zone3_BSP[i][1];
        }
    }

    else if (currentLvl==4)
    {
        map_total_BB=sizeof(zone4_bb)/sizeof(grids);
        for (i=0; i<map_total_BB; i++)
        {
            map_BB[i].PointX = zone4_bb[i].PointX; map_BB[i].PointY = zone4_bb[i].PointY; map_BB[i].PointZ = zone4_bb[i].PointZ;
            map_BB[i].LengthX = zone4_bb[i].LengthX; map_BB[i].LengthY = zone4_bb[i].LengthY; map_BB[i].LengthZ = zone4_bb[i].LengthZ;
            map_BB[i].Mask = zone4_bb[i].Mask; map_BB[i].SlopeRXAngle = zone4_bb[i].SlopeRXAngle; map_BB[i].SlopeRZAngle = zone4_bb[i].SlopeRZAngle;
        }

    }

}



int mask_collision(int x, int z, int i)
{
    register int  distance;
    if (x < 0) x = 0;
    else if (x >= map_BB[i].LengthX) x = map_BB[i].LengthX - 1;

    if (z < 0) z = 0;
    else if (z >= map_BB[i].LengthZ) z = map_BB[i].LengthZ - 1;

    if (map_BB[i].SlopeRXAngle != 0)
                distance = Slopes[map_BB[i].Mask][z];

    else  distance = Slopes[map_BB[i].Mask][x];
return distance;
}

/*
int X_Axis_collision_detection(const int x, const int xSpeed, const int y, const int ySpeed, const int z, const int zSpeed, const int w, const int h)
{
    register int lowestXdist = JO_CHANGE_SIGN(JO_MAP_NO_COLLISION);//Unused at the moment, could be used to detect where the bullets should "stop" in a FPS game
    register int Xdist = 0;
    register int i = 0;
    register bool collision = false;
    register int currentPointX, currentPointY, currentPointZ, currentLengthX, currentLengthY, currentLengthZ;
    register int currentMask;

    for (JO_ZERO(i); i < map_total_BB; i++)
    {
        currentPointX = map_BB[i].PointX; currentLengthX = map_BB[i].LengthX; currentPointY = map_BB[i].PointY; currentLengthY = map_BB[i].LengthY; currentPointZ = map_BB[i].PointZ; currentLengthZ = map_BB[i].LengthZ;
        currentMask = map_BB[i].Mask;

        if (jo_square_intersect((currentPointX), (currentPointZ), (currentLengthX), (currentLengthZ), x + xSpeed, z, w, w))
            {
                if ((currentPointY <= y + ySpeed + h)&&(currentPointY+currentLengthY>=y + ySpeed - h))
                {

                   if (currentMask < 0)
                    {
                          if (currentPointY + currentLengthY <=y+ySpeed) player.is_crouching = true;//Need to be referenced instead
                          collision = true;
                          Xdist = 0;
                   }
                    else
                    {
                        Xdist = mask_collision(x + JO_DIV_BY_2(w) + xSpeed - currentPointX, z + JO_DIV_BY_2(w) + zSpeed - currentPointZ, i);
                        if ((currentPointY + Xdist <= y + ySpeed + h)&&(currentPointY+currentLengthY+Xdist>=y + ySpeed - h))
                        {
                            if (currentPointY+currentLengthY<=y + ySpeed) player.is_crouching=true;
                            collision = true;
                        }
                         Xdist =  currentPointX - x;
                         if ((Xdist) < (lowestXdist)) lowestXdist = Xdist;
                         else Xdist = lowestXdist;
                    }
                }
            }
    }
    if (collision == true) return Xdist;
    else return JO_CHANGE_SIGN(JO_MAP_NO_COLLISION);
}*/

/*
int Z_Axis_collision_detection(const int x, const int xSpeed, const int y, const int ySpeed, const int z, const int zSpeed, const int w, const int h)
{
    register int lowestZdist = JO_CHANGE_SIGN(JO_MAP_NO_COLLISION);
    register int Zdist = 0;
    register int i = 0;
    register bool collision = false;
    register int currentPointX, currentPointY, currentPointZ, currentLengthX, currentLengthY, currentLengthZ;
    register int currentMask;
    register int currentRX, currentRZ;

    for (JO_ZERO(i); i < map_total_BB; i++)
    {
        currentPointX = map_BB[i].PointX; currentLengthX = map_BB[i].LengthX; currentPointY = map_BB[i].PointY; currentLengthY = map_BB[i].LengthY; currentPointZ = map_BB[i].PointZ; currentLengthZ = map_BB[i].LengthZ;
        currentMask = map_BB[i].Mask; currentRX = map_BB[i].SlopeRXAngle; currentRZ = map_BB[i].SlopeRZAngle;

        if (jo_square_intersect((currentPointX), (currentPointZ), (currentLengthX), (currentLengthZ), x + xSpeed, z + zSpeed, w, w))
            {
                if ((currentPointY <= y + ySpeed + h)&&(currentPointY+currentLengthY>=y+ySpeed-h))
                {
                   if (currentMask < 0)
                    {
                        if (currentPointY + currentLengthY <= y+ySpeed) player.is_crouching = true;
                        collision = true;
                        Zdist = 0;
                    }
                    else
                    {
                        Zdist = mask_collision(x + JO_DIV_BY_2(w) + xSpeed - currentPointX, z + JO_DIV_BY_2(w) + zSpeed - currentPointZ, i);
                        if ((currentPointY + Zdist <= y + ySpeed + h)&&(currentPointY+currentLengthY+Zdist>=y + ySpeed -h))
                        {
                            if (currentPointY+currentLengthY<=y + ySpeed)player.is_crouching = true;
                            collision = true;
                        }

                        Zdist =  currentPointZ - z;
                        if ((Zdist) < (lowestZdist)) lowestZdist = Zdist;
                        else Zdist = lowestZdist;
                    }
                }
            }
    }
    if (collision == true) return Zdist;
    else return JO_CHANGE_SIGN(JO_MAP_NO_COLLISION);
}
*/

int X_Axis_collision_detection(const int idx, const int x, const int xSpeed, const int y, const int ySpeed, const int z, const int zSpeed, const int w, const int h)
{
        int Xdist = 0;
        bool collision = false;

        //Xdist = mask_collision(x + JO_DIV_BY_2(w) + xSpeed - currentPointX, z + JO_DIV_BY_2(w) + zSpeed - currentPointZ, i);
        //if (jo_square_intersect((map_BB[idx].PointX), (map_BB[idx].PointZ), (map_BB[idx].LengthX), (map_BB[idx].LengthZ), x + xSpeed, z + zSpeed, w, w))
        if (jo_square_intersect((map_BB[idx].PointX), (map_BB[idx].PointZ), (map_BB[idx].LengthX), (map_BB[idx].LengthZ), x + xSpeed, z, w, w))
            {
                if ((map_BB[idx].PointY <= y + ySpeed + h)&&(map_BB[idx].PointY + map_BB[idx].LengthY >= y + ySpeed - h))
                {
                   if (map_BB[idx].Mask < 0)
                    {
                        if (map_BB[idx].PointY + map_BB[idx].LengthY <= y+ySpeed) player.is_crouching = true;
                        collision = true;
                        Xdist = 0;
                    }
                    else
                    {
                        Xdist = mask_collision(x + JO_DIV_BY_2(w) + xSpeed - map_BB[idx].PointX, z + JO_DIV_BY_2(w) + zSpeed - map_BB[idx].PointZ, idx);
                        if ((map_BB[idx].PointY + Xdist <= y + ySpeed + h)&&(map_BB[idx].PointY + map_BB[idx].LengthY + Xdist >= y + ySpeed -h))
                        {
                            if (map_BB[idx].PointY + map_BB[idx].LengthY <= y + ySpeed) player.is_crouching = true;
                            collision = true;
                        }

                        Xdist =  map_BB[idx].PointX - x;
                    }
                }
            }
    if (collision == true) return Xdist;
    else return JO_CHANGE_SIGN(JO_MAP_NO_COLLISION);
}


int Z_Axis_collision_detection(const int idx, const int x, const int xSpeed, const int y, const int ySpeed, const int z, const int zSpeed, const int w, const int h)
{
        int Zdist = 0;
        bool collision = false;

        if (jo_square_intersect((map_BB[idx].PointX), (map_BB[idx].PointZ), (map_BB[idx].LengthX), (map_BB[idx].LengthZ), x, z + zSpeed, w, w))
            {
                if ((map_BB[idx].PointY <= y + ySpeed + h)&&(map_BB[idx].PointY + map_BB[idx].LengthY >= y + ySpeed - h))
                {
                   if (map_BB[idx].Mask < 0)
                    {
                        if (map_BB[idx].PointY + map_BB[idx].LengthY <= y+ySpeed) player.is_crouching = true;
                        collision = true;
                        Zdist = 0;
                    }
                    else
                    {
                        Zdist = mask_collision(x + JO_DIV_BY_2(w) + xSpeed - map_BB[idx].PointX, z + JO_DIV_BY_2(w) + zSpeed - map_BB[idx].PointZ, idx);
                        if ((map_BB[idx].PointY + Zdist <= y + ySpeed + h)&&(map_BB[idx].PointY + map_BB[idx].LengthY + Zdist >= y + ySpeed -h))
                        {
                            if (map_BB[idx].PointY + map_BB[idx].LengthY <= y + ySpeed) player.is_crouching = true;
                            collision = true;
                        }

                        Zdist =  map_BB[idx].PointZ - z;
                        //if ((Zdist) < (lowestZdist)) lowestZdist = Zdist;
                        //else Zdist = lowestZdist;
                    }
                }
            }
    //}
    if (collision == true) return Zdist;
    else return JO_CHANGE_SIGN(JO_MAP_NO_COLLISION);
}

int Y_Axis_collision_detection(const int idx, int previousYdist, const int x, const int xSpeed, const int y, const int ySpeed, const int z, const int zSpeed, const int w, const int h, _player *currentPlayer)
{
    int Ydist = 0;
    int lowestYdist = previousYdist;
    bool collision = false;



    if (jo_square_intersect((map_BB[idx].PointX), (map_BB[idx].PointZ), (map_BB[idx].LengthX), (map_BB[idx].LengthZ), x + (xSpeed>>1), z + (zSpeed>>1), w, w))
        {
        if ((map_BB[idx].PointY <= y + h + ySpeed)&&(map_BB[idx].PointY+ map_BB[idx].LengthY >=y+ySpeed-h))
        {
            if (map_BB[idx].Mask < 0)
            {
                    collision = true;

                       Ydist =  map_BB[idx].PointY - y - h;
                       if ((Ydist) < (lowestYdist)) lowestYdist = Ydist;
                       else Ydist = lowestYdist;
            }
            else
            {
              Ydist = mask_collision(x + JO_DIV_BY_2(w) - map_BB[idx].PointX, z + JO_DIV_BY_2(w) - map_BB[idx].PointZ, idx);
              if ((map_BB[idx].PointY + Ydist <= y + h + ySpeed)&&(map_BB[idx].PointY + map_BB[idx].LengthY +Ydist>=y + ySpeed))
              {
                        collision = true;
              }
                        Ydist =  map_BB[idx].PointY + Ydist - y - h;
                        if ((Ydist) < (lowestYdist)) lowestYdist = Ydist;
                        else Ydist = lowestYdist;
            }
        }
        /* Lazy way, I will improve it */
        else if (jo_square_intersect(map_BB[idx].PointX,  map_BB[idx].PointY, map_BB[idx].LengthX, map_BB[idx].LengthY, x, y, 1, 200))
                    {
                        if (collision==false && map_BB[idx].Mask<0)
                        {
                            Ydist =  map_BB[idx].PointY - y - h;
                            if ((Ydist) < (lowestYdist)) lowestYdist = Ydist;
                            else Ydist = lowestYdist;
                        }
                    }
        }


  if (collision == true) {currentPlayer->v_collision = true;}
        return Ydist;
}

/***************
* Vertical hit detection
***************/
/*
int Y_Axis_collision_detection(const int idx, const int x, const int xSpeed, const int y, const int ySpeed, const int z, const int zSpeed, const int w, const int h, _player *currentPlayer)
{
    register int lowestYdist = 32767;
    register int Ydist = 0;
    register unsigned int i = 0;
    register bool collision = false;
    register int currentPointX, currentPointY, currentPointZ, currentLengthX, currentLengthY, currentLengthZ;
    register int currentMask;

    for (i=BSP_BB[idx].BB_start; i < BSP_BB[idx].BB_end; i++)
    //for (i=0; i < map_total_BB; i++)
    {
    currentPointX = map_BB[i].PointX; currentLengthX = map_BB[i].LengthX; currentPointY = map_BB[i].PointY; currentLengthY = map_BB[i].LengthY; currentPointZ = map_BB[i].PointZ; currentLengthZ = map_BB[i].LengthZ;
    currentMask = map_BB[i].Mask;

    if (jo_square_intersect((currentPointX), (currentPointZ), (currentLengthX), (currentLengthZ), x + xSpeed, z + zSpeed, w, w))
        {
        if ((currentPointY <= y + h + ySpeed)&&(currentPointY+currentLengthY>=y+ySpeed-h))
        {
            if (currentMask < 0)
            {
                    collision = true;
                    //if (currentPointY <= y)
                    //{
                       Ydist =  currentPointY - y - h;
                       if ((Ydist) < (lowestYdist)) lowestYdist = Ydist;
                       else Ydist = lowestYdist;
                    //}
            }
            else
            {
              Ydist = mask_collision(x + JO_DIV_BY_2(w) - currentPointX, z + JO_DIV_BY_2(w) - currentPointZ, i);
              if ((currentPointY + Ydist <= y + h + ySpeed)&&(currentPointY+currentLengthY+Ydist>=y + ySpeed))
              {
                        collision = true;
                        //currentPlayer->rz = map_BB[i].SlopeRZAngle;
                        //currentPlayer->rx = map_BB[i].SlopeRXAngle;
              }
                        Ydist =  currentPointY + Ydist - y - h;
                        if ((Ydist) < (lowestYdist)) lowestYdist = Ydist;
                        else Ydist = lowestYdist;
            }
        }
        else if (jo_square_intersect(currentPointX, currentPointY, currentLengthX, currentLengthY, x, y, 1, 200))
                    {
                        if (collision==false && currentMask<0)
                        {
                            Ydist =  currentPointY - y - h;
                            if ((Ydist) < (lowestYdist)) lowestYdist = Ydist;
                            else Ydist = lowestYdist;
                        }
                    }
    }
}

  if (collision == true) {currentPlayer->v_collision = true;}
        return Ydist;
}*/

/*
bool      X_axis_collision(int next_X, int next_Y, int next_Z, _player * currentPlayer)
{
    int Xdist = X_Axis_collision_detection(currentPlayer->x - width2, next_X, currentPlayer->y, next_Y, currentPlayer->z - width2, next_Z, width, height2 - player.crouchH);
    if (Xdist == JO_CHANGE_SIGN(JO_MAP_NO_COLLISION))
        return false;
    currentPlayer->XSP = 0;
    return true;
}

bool      Z_axis_collision(int next_X, int next_Y, int next_Z, _player * currentPlayer)
{
    int Zdist = Z_Axis_collision_detection(currentPlayer->x - width2, next_X, currentPlayer->y, next_Y, currentPlayer->z - width2, next_Z, width, height2 - player.crouchH);
    if (Zdist == JO_CHANGE_SIGN(JO_MAP_NO_COLLISION))
        return false;
    currentPlayer->ZSP = 0;
    return true;
}*/



/*
bool Y_axis_collision(int idx, int next_X, int next_Y, int next_Z, _player *currentPlayer)
{
    int Ydist = Y_Axis_collision_detection(idx, currentPlayer->x - width2, next_X, currentPlayer->y + height2, next_Y, currentPlayer->z - width2 , next_Z, width, height - player.crouchH, &player); //bug if I pass currentplayer, so I pass player instead. To be modified
    //jo_printf(0, 15, "Ydist : %d  ", Ydist);

    if (((Ydist >= -80 && Ydist < 0) || (Ydist > 0 && Ydist <= 5)) && (currentPlayer->YSP >= 0 || currentPlayer->YSP <= -1536))  //If you are under the ground, instead of being stuck, you are being poped-up
        {
        player.can_jump = true;
        if (Ydist <= -10) player.y -= 10;  //Makes a smoother movement when you climb stairs or go up
        else       player.y += Ydist;
        player.v_collision = true;
        }

    else if (Ydist <= height && Ydist > 5 && (currentPlayer->YSP >= 0)) //The player is falling back to the ground and close to it, so we allow him to jump again
        {
            player.can_jump = true;
            player.v_collision = false;
        }
    else if (Ydist < -80)
    {
        player.YSP = 0; //Sets the speed to zero to avoid that even with gravity you still go up
        player.v_collision = false;
        //player.is_ducking +=2;
        //if (player.is_ducking>duckingheight) player.is_ducking=duckingheight;
    }


   if (currentPlayer->v_collision == true) //We stop the player's vertical speed since we detected a vertical collision.
        {
            player.can_jump = true;
            player.is_in_air = false;
            player.YSP = 0;
           // if (player.is_ducking > 0) player.is_ducking-=2;
        }
   else  //No vertical collision, so the player is in the air, we apply gravity
    {
        player.is_in_air = true;
        player.YSP += 96;
    }

if (currentPlayer->YSP > 6144) player.YSP=6144;
return player.v_collision;
}*/


void player_hurt(bool autodeath, char player_id)
{
    if (player_id == 0)
    {
         if (autodeath) _reset(&player); //bug with passing &currentPlayer, no time to look it up so I just use &player for the time being
    }

}




/*************************************
The function to call for collision handling.
Really ugly, I didn't take time to improve the code for easier reading
*************************************/
void collision_handling(_player *currentPlayer)
{
currentPlayer->v_collision = false;
currentPlayer->h_collision = false;
currentPlayer->is_crouching=false;
currentPlayer->can_jump = false;

    int next_X, next_Y, next_Z;
    int LowestDist = 65536;
    int Ydist=65536;

    if (currentPlayer->XSP > 0)    next_X = currentPlayer->XSP + 26;
    else if (currentPlayer->XSP < 0) next_X = currentPlayer->XSP - 26;
    else next_X = 0;

    if (currentPlayer->ZSP > 0) next_Z = currentPlayer->ZSP + 26;
    else if (currentPlayer->ZSP < 0) next_Z = currentPlayer->ZSP - 26;
    else next_Z = 0;

    next_Y = (currentPlayer->YSP>>8);


    register unsigned int i=0;
    register int ii=0;
    register int checks=0;  /* Just to compare how many "checks" we do and the impact on performance on real hardware  */

jo_printf(0, 8, "Values :                          ");
    /* First BSP level */
    for (i=0; i<mesh_tot; i++)
    {
        if (jo_square_intersect(BSP_BB[i].MinValue.x, BSP_BB[i].MinValue.z, BSP_BB[i].LengthVal.x, BSP_BB[i].LengthVal.z, currentPlayer->x- width2 -next_X, currentPlayer->z - width2 - next_Z, width, width))
       // if ((BSP_BB[i].MinValue.x <= currentPlayer->x + width2 + next_X)&&(BSP_BB[i].MinValue.x + BSP_BB[i].LengthVal.x >= currentPlayer->x+next_X-width2))  /** Will have problems because of auto-subdivision? **/
        {

       // int Xdist = X_Axis_collision_detection(currentPlayer->x - width2, next_X, currentPlayer->y, next_Y, currentPlayer->z - width2, next_Z, width, height2 - player.crouchH);
           // if ((BSP_BB[i].MinValue.z <= currentPlayer->z + width2 - next_Z)&&(BSP_BB[i].MinValue.z + BSP_BB[i].LengthVal.z >= currentPlayer->z - next_Z - width2))
            //{
                if ((BSP_BB[i].MinValue.y <= currentPlayer->y + height2 + next_Y)&&(BSP_BB[i].MinValue.y + BSP_BB[i].LengthVal.y >= currentPlayer->y + next_Y - height2))
                {

                    //if (Y_axis_collision(i, -next_X, next_Y, -next_Z, &player) == true) next_Y = 0;


                    /* Second BSP level */

                    for (ii=BSP_BB[i].BB_start; ii<BSP_BB[i].BB_end; ii++)
                    {
                      if (jo_square_intersect(map_BB[ii].PointX, map_BB[ii].PointZ, map_BB[ii].LengthX, map_BB[ii].LengthZ, currentPlayer->x - next_X - width2, currentPlayer->z - width2 - next_Z, width, width ))
                        {
                         // if ((map_BB[ii].PointY <= currentPlayer->y + height2 + next_Y)&&(map_BB[ii].PointY + map_BB[i].LengthY >= currentPlayer->y+next_Y-height2))
                         //       {
                                        if (X_Axis_collision_detection(ii, currentPlayer->x - width2, -next_X, currentPlayer->y, next_Y, currentPlayer->z - width2, -next_Z, width, height2 - player.crouchH) != JO_CHANGE_SIGN(JO_MAP_NO_COLLISION))
                                            {currentPlayer->XSP = 0; next_X = 0;}
                                        if (Z_Axis_collision_detection(ii, currentPlayer->x - width2, -next_X, currentPlayer->y, next_Y, currentPlayer->z - width2, -next_Z, width, height2 - player.crouchH) != JO_CHANGE_SIGN(JO_MAP_NO_COLLISION))
                                            {currentPlayer->ZSP = 0; next_Z = 0;}
                                        Ydist = Y_Axis_collision_detection(ii, LowestDist, currentPlayer->x - width2, -next_X, currentPlayer->y + height2, next_Y, currentPlayer->z - width2, -next_Z, width, height - player.crouchH, &player);
                                        if (Ydist < LowestDist) LowestDist = Ydist;
                                        else Ydist = LowestDist;

                                //Y_Axis_collision_detection(idx, currentPlayer->x - width2, next_X, currentPlayer->y + height2, next_Y, currentPlayer->z - width2 , next_Z, width, height - player.crouchH, &player); //bug if I pass currentplayer, so I pass player instead. To be modified
                          //      } //checks += 2;
                        }

                        /*if ((map_BB[ii].PointX <= currentPlayer->x + width2 - next_X)&&(map_BB[ii].PointX + map_BB[i].LengthX >= currentPlayer->x - next_X - width2))
                        {
                            if ((map_BB[ii].PointZ <= currentPlayer->z + width2 - next_Z)&&(map_BB[ii].PointZ + map_BB[i].LengthZ >= currentPlayer->z - next_Z-width2))
                            {
                               if ((map_BB[ii].PointY <= currentPlayer->y + height2 + next_Y)&&(map_BB[ii].PointY + map_BB[i].LengthY >= currentPlayer->y+next_Y-height2))
                                {
                                        if (X_Axis_collision_detection(ii, currentPlayer->x - width2, -next_X, currentPlayer->y, next_Y, currentPlayer->z - width2, -next_Z, width, height2 - player.crouchH) != JO_CHANGE_SIGN(JO_MAP_NO_COLLISION))
                                            {currentPlayer->XSP = 0; next_X = 0;}
                                        if (Z_Axis_collision_detection(ii, currentPlayer->x - width2, -next_X, currentPlayer->y, next_Y, currentPlayer->z - width2, -next_Z, width, height2 - player.crouchH) != JO_CHANGE_SIGN(JO_MAP_NO_COLLISION))
                                            {currentPlayer->ZSP = 0; next_Z = 0;}


                                } checks += 2;
                            } checks +=2;
                        } checks +=2;*/

                    }

                } //checks+=2;
            //} checks+=2;
        } //checks += 4;
    }



        if (((Ydist >= -80 && Ydist < 0) || (Ydist > 0 && Ydist <= 5)) && (currentPlayer->YSP >= 0 || currentPlayer->YSP <= -1536))  //If you are under the ground, instead of being stuck, you are being poped-up
        {
            player.can_jump = true;
            if (Ydist <= -10) player.y -= 10;  //Makes a smoother movement when you climb stairs or go up
            else       player.y += Ydist;
            player.v_collision = true;
        }

        else if (Ydist <= height && Ydist > 5 && (currentPlayer->YSP >= 0)) //The player is falling back to the ground and close to it, so we allow him to jump again
        {
            player.can_jump = true;
            player.v_collision = false;
        }
        else if (Ydist < -80)
        {
            player.YSP = 0;
            player.v_collision = false;
        }


    if (currentPlayer->v_collision == true) //We stop the player's vertical speed since we detected a vertical collision.
    {
        player.can_jump = true;
        player.is_in_air = false;
        player.YSP = 0;
               // if (player.is_ducking > 0) player.is_ducking-=2;
    }
    else  //No vertical collision, so the player is in the air, we apply gravity
    {
        player.is_in_air = true;
        player.YSP += 96;
    }

    if (currentPlayer->YSP > 6144) player.YSP=6144;



    if (player.is_crouching==true) player.crouchH += crouchingincrease;
    else if (player.crouchH>0) player.crouchH--;
    if (player.crouchH>crouchingheight) player.crouchH=crouchingheight;

    //jo_printf(0, 28, "Crouch height :  %d", currentPlayer->crouchH);

    if (currentPlayer->y >= 600 || currentPlayer->y <= -8000) player_hurt(true, 0); //Kill the player if you fall, I made it so the VDP2 plane prevents you from falling. You can just change the conditions to allow it.
}


