#include <jo/jo.h>
#include "Player.h"
#include "Control.h"


_player player;
void switch_weapons(_player * currentPlayer, bool switch_direction);  //Keeping it simple = 0 -> left, 1 -> right

/**********************
Credits for the smooth movement controls go to by Danny (JO Engine Forum user).
I just adapted them for my collision functions (and removed SGL references)
Bugs : There is a bug I don't understand with Sin/Cos where you go faster one direction. Cause unknown for now, but if you find it, make sure you tell me!
To do : Add a view button (Done 28/07/2017 - Improved on 10/08/2017)
To do : Add a firing button/mecanism (Done 29/07/2017, but it only produces an effect, has no other behaviour for now)
To do : Add a menu when pressing start (including the option to restart).
To do : Add weapon switching (Done 29/07/2017)
**********************/
void gamepad_control()
{
    static int draw_distance = 1500;
    static char key_timer = -1;
    static bool reset_vertical_view = false;
    const unsigned short speedvalue = 90*JO_FRAMERATE;
    const unsigned short speedincrease = 10*JO_FRAMERATE;
    const unsigned short turnincrease = 2*JO_FRAMERATE;

if (jo_is_pad1_available == false)
{
    jo_printf(10, 10, "ERROR : NO PAD CONNECTED IN PORT 1");
    return;
}
else jo_printf(10, 10, "                                 "); //just to erase the line if you connect a gamepad after the error


	if (jo_is_pad1_key_down(JO_KEY_START))
    {
        if (jo_is_pad1_key_pressed(JO_KEY_L) || jo_is_pad1_key_pressed(JO_KEY_R))
            _changeMap();
        else
            _reset(&player);
    }
    if (jo_is_pad1_key_down(JO_KEY_X))
    {
        if (key_timer > 1) {key_timer=-1; reset_vertical_view=true;}
    }
    else if (jo_is_pad1_key_pressed(JO_KEY_X))  //If you keep X pressed, you can look around
    {
        if (key_timer > 60) {key_timer= 60;} //Can be improved. The idea is just to reset the view if you press the button long enough, but press X again quickly enough (it avoids resetting the view when you just want to ajust it. So you kind of double press X...). Maybe it's not even necessary?
        else key_timer++;

        if (jo_is_pad1_key_pressed(JO_KEY_UP))
        {player.vertical_angle+=1; if (player.vertical_angle>45) player.vertical_angle=45;}
        else if (jo_is_pad1_key_pressed(JO_KEY_DOWN))
        {player.vertical_angle-=1; if (player.vertical_angle<-45) player.vertical_angle=-45;}

        if (player.movement_speed>speedincrease)player.movement_speed-=speedincrease;
        else if (player.movement_speed<-speedincrease) player.movement_speed+=speedincrease;
        else player.movement_speed=0;
    }
    else
    {
        key_timer--;  if (key_timer<-1) key_timer=-1;
        if (jo_is_pad1_key_pressed(JO_KEY_UP))
        {	    if ((player.movement_speed+=speedincrease)>speedvalue) player.movement_speed=speedvalue;    }
        else if (jo_is_pad1_key_pressed(JO_KEY_DOWN))
        {	    if ((player.movement_speed-=speedincrease)<-speedvalue) player.movement_speed=-speedvalue;	}
        else if (player.movement_speed > speedincrease) player.movement_speed-=speedincrease;
        else if (player.movement_speed < -speedincrease) player.movement_speed+=speedincrease;
        else player.movement_speed = 0;
    }

    if (jo_is_pad1_key_down(JO_KEY_Y))
        switch_weapons(&player, 0);
    else if (jo_is_pad1_key_down(JO_KEY_Z))
        switch_weapons(&player, 1);

	if (jo_is_pad1_key_pressed(JO_KEY_L) && jo_is_pad1_key_pressed(JO_KEY_R))
    {
        //Could be used for a modifier or for a debug menu. It also avoids straffing one direction when you press both L and R
    }
    else if (jo_is_pad1_key_pressed(JO_KEY_L))
    {   if ((player.lateral_speed += speedincrease) > speedvalue) player.lateral_speed = speedvalue;
    }
    else if (jo_is_pad1_key_pressed(JO_KEY_R))
    {   if ((player.lateral_speed -= speedincrease) < -speedvalue) player.lateral_speed = -speedvalue;    }
    else if (player.lateral_speed > speedincrease) player.lateral_speed -=speedincrease;
    else if (player.lateral_speed < -speedincrease) player.lateral_speed += speedincrease;
    else player.lateral_speed = 0;


	if (jo_is_pad1_key_pressed(JO_KEY_RIGHT))
		player.angle_increment += turnincrease;
	else if (jo_is_pad1_key_pressed(JO_KEY_LEFT))
		player.angle_increment -= turnincrease;

	/****** For testing the draw distance, mainly for real hardware ******/
    if (jo_is_pad1_key_down(JO_KEY_C))
    {
        if (jo_is_pad1_key_pressed(JO_KEY_L) || jo_is_pad1_key_pressed(JO_KEY_R)) {player.YSP = -5000;}
        else
        {
            if (draw_distance == 2000) draw_distance = 800;
            else draw_distance += 100;
            jo_3d_window(0, 0, JO_TV_WIDTH-1, JO_TV_HEIGHT-1-40, draw_distance, JO_TV_WIDTH_2, JO_TV_HEIGHT_2-20); //Includes the draw distance (currently 2500)
        }
    }

    if (player.is_in_air==false && player.can_jump==true)
    {
        if (jo_is_pad1_key_down(JO_KEY_B))
        {
            player.YSP -= 2048;
            player.is_in_air = true;
        }
    }

    if (player.is_firing==0)
    {
        if (jo_is_pad1_key_down(JO_KEY_A))
        {
            player.is_firing=20;  //Should be set depending on the weapons' value. Kind of like a timer to allow you to fire again, the firerate...
        }
    }


    player.ry -= player.angle_increment;
    if (player.ry >= 360) player.ry -= 360; //Avoid overflows
    else if (player.ry < 0) player.ry += 360;


        if (player.movement_speed > 0)
        {
            player.XSP += (jo_cos_mult(player.movement_speed, player.ry)/10);
            player.ZSP += (jo_sin_mult(player.movement_speed, player.ry)/10);
        }
        else if (player.movement_speed < 0)
        {
            player.XSP += (jo_cos_mult(player.movement_speed+5, player.ry)/10); //Integer right shift issue with Cos/Sin functions, cheap semi-workaround
            player.ZSP += (jo_sin_mult(player.movement_speed+5, player.ry)/10);

        }

        if (player.lateral_speed > 0)
        {
            player.XSP -= (jo_sin_mult(player.lateral_speed, player.ry)/10);
            player.ZSP += (jo_cos_mult(player.lateral_speed, player.ry)/10);
        }
        else if (player.lateral_speed < 0)
        {
            player.XSP -= (jo_sin_mult(player.lateral_speed+5, player.ry)/10);  //Integer right shift issue with Cos/Sin functions, cheap semi-workaround
            player.ZSP += (jo_cos_mult(player.lateral_speed+5, player.ry)/10);
        }

	//position_increment[X] -= movement_speed * slSin(angle[Z]) / 10;   --> The current movement has problems with diagonals and goes faster on one axis. Problem unknown for now, if you find a solution please share it with me!
	//position_increment[Y] -= movement_speed * slCos(angle[Z]) / 10;
    if (reset_vertical_view==true)
    {
        if (player.vertical_angle >= 5) player.vertical_angle -= 5;
        else if (player.vertical_angle <= -5) player.vertical_angle += 5;
        else  {player.vertical_angle=0;reset_vertical_view=false;}
    }

    player.rz = player.vertical_angle;

}

void switch_weapons(_player * currentPlayer, bool switch_direction)  //Keeping it simple = 0 -> left, 1 -> right
{
    int currentWeapon = currentPlayer->weapon;
    int i=0;

    for (i=0; i<10; i++)
    {
        if (switch_direction==false) {currentWeapon--; if (currentWeapon<0) currentWeapon=9;}
        else {currentWeapon++; if (currentWeapon>9) currentWeapon = 0;}

        if (currentPlayer->owned_weapons[currentWeapon] == true && currentPlayer->ammo[currentWeapon]>0) {currentPlayer->weapon=currentWeapon; return;}

    }
}



