#include <jo/jo.h>
unsigned int mesh_tot;

#include "Player.h"
#include "Display.h"
#include "VDP2.h"
#include "SOURCE/QuakeHud.h"

_BB_Hitbox  BSP_BB[256];
static jo_3d_mesh *LevelMesh[256];

#define draw_distance (1500)
#define draw_distance2 (3000)
#define WORK_RAM_LOW 0x00200000


bool useGouraudDepth = false;
static jo_img img[50];

jo_camera           cam;

int weapon_id;
_player player;
bool TVstatus = true;


void _reset(_player *currentPlayer);




/******************
Imported from SGL FPS demo, for testing depth (make everything fade to black when it's far from the camera with gouraud shading)
******************/
#define	GRTBL(r,g,b)	(((b&0x1f)<<10) | ((g&0x1f)<<5) | (r&0x1f) )
static	unsigned short	DepthData[32] = {
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 16, 16, 16 ),
	GRTBL( 15, 15, 15 ),
	GRTBL( 14, 14, 14 ),
	GRTBL( 13, 13, 13 ),
	GRTBL( 12, 12, 12 ),
	GRTBL( 11, 11, 11 ),
	GRTBL( 10, 10, 10 ),
	GRTBL(  9,  9,  9 ),
	GRTBL(  8,  8,  8 ),
	GRTBL(  7,  7,  7 ),
	GRTBL(  6,  6,  6 ),
	GRTBL(  5,  5,  5 ),
	GRTBL(  4,  4,  4 ),
	GRTBL(  3,  3,  3 ),
	GRTBL(  2,  2,  2 ),
	GRTBL(  1,  1,  1 ),
	GRTBL(  0,  0,  0 ),
};


#include "Loading.h"


void load_permanent_textures(void)
{
    jo_sprite_add_bin("WPN", "GFLASH.BIN", JO_COLOR_Red);    //jo_sprite_add_bin("TEX", "SHOT.BIN", JO_COLOR_Transparent);
    weapon_id=jo_sprite_add_bin("WPN", "BLASTER.BIN", JO_COLOR_Red);
    jo_sprite_add_bin("WPN", "SHOTGUN.BIN", JO_COLOR_Red);
}


/*****
Temporary, will add a feature in the Map tool instead, now it only works for one texture, which is really bad of course
*****/
void animate_texture(int sprite_id, int frame_rate, int nb_frames)
{
    /*static int start_frame;
    static int current_frame;
    static int frame_counter;
    static unsigned int start_poly_id[20];
    static unsigned int end_poly_id[20];
    unsigned int i;
    unsigned int ii;

    if (sprite_id != -1)  //Initialize the list;
    {
        start_frame = sprite_id;
        current_frame = start_frame;
        for (JO_ZERO(i); i < mesh_tot; i++)
        {
            start_poly_id[i]=65535; //Instead of zero which won't allow us to verify if it's correct, we put an impossible number of polygons (for the Saturn)
            end_poly_id[i]=65535;
            for (JO_ZERO(ii); ii < LevelMesh[i]->data.nbPolygon; ii++)
            {
                if (LevelMesh[i]->data.attbl[ii].texno == start_frame)
                {
                    if (start_poly_id[i]==65535) {start_poly_id[i]=ii; end_poly_id[i]=ii;}
                    else end_poly_id[i]++;  //Notice that it won't work if the polygons aren't exactly one after the other. Usualy Obj files regroup polygons per material, so it should be fine for now
                }
            }
        }
    }
    else
    {
        for (JO_ZERO(i); i<mesh_tot; i++)
        {
            if (start_poly_id[i]!=65535)
            {
                for (ii = start_poly_id[i]; ii<end_poly_id[i]+1; ii++)
                {
                    LevelMesh[i]->data.attbl[ii].texno = current_frame;
                }
                frame_counter++;
                if (frame_counter>=frame_rate) {current_frame++; frame_counter=0;}
                if (current_frame>= start_frame+nb_frames) current_frame=start_frame;
            }
        }
    }
*/
}




void init_display(void)
{
    jo_core_init(JO_COLOR_Black);
    load_permanent_textures();
    _changeMap();
    jo_set_background_sprite(&Spritehudquake1, 0, 201);
    slPriorityNbg1(6);    slPrioritySpr0(5);
    //initialize_VDP2();
    jo_3d_camera_init(&cam);
    jo_3d_camera_set_viewpoint(&cam, 18, 0, 0);
    jo_3d_camera_set_target(&cam, 0, 0, 0);
    jo_3d_camera_set_z_angle(&cam, 0);
    jo_3d_window(0, 0, JO_TV_WIDTH-1, JO_TV_HEIGHT-1 - 40, draw_distance, JO_TV_WIDTH_2, JO_TV_HEIGHT_2 - 20); //Includes the draw distance. Also I left 40 pixels for a HUD.
    jo_3d_perspective_angle(70); //FOV
}

void display_NBG2 (int x, int y)
{
    //draw_VDP2_background(x, y);
}

//inline void  checkOnScreen();

void			my_draw()
{
    jo_printf(0, 0, "FPS COLLISION DEMO");
    jo_printf(0, 1, "X :  %d  ", player.x);
    jo_printf(0, 2, "Y :  %d  ", player.y);
    jo_printf(0, 3, "Z :  %d  ", player.z);
    jo_printf(0, 4, "Rotation Y :  %d  ", player.ry);

        animate_texture(-1, 4, 4);
        static bool direction;
        static char yM; //For moving the weapon around

        jo_3d_camera_look_at(&cam);                 //jo_3d_light(-player.x, -player.y + yM, -player.z);  //For the light source
        jo_3d_camera_set_z_angle(&cam, -player.angle_increment<<1); //Little turning effect

        if (player.is_moving == true) //Add some movements to the weapons to simulate walking
        {
            if (direction==true){yM++; if (yM>20) direction=false;}
            else            {yM--; if (yM <=0) direction = true;}
        }

        if (player.is_firing > 0)
        {
            jo_sprite_enable_gouraud_shading();
            jo_set_gouraud_shading_colors(33560+(player.is_firing>>2), 32776+(player.is_firing>>2), 32776+(player.is_firing>>2), 0);  //Quickly made, the colors could be better

            if (player.weapon==0)
            {
             jo_sprite_draw3D(weapon_id, 70+(player.is_firing), 80+(yM>>1)+(player.is_firing>>1), 15);
            }
            else if (player.weapon==1)
            {
                jo_sprite_draw3D(weapon_id+1,0, 90+(yM>>1)+(player.is_firing), 15);
                jo_sprite_change_sprite_scale(player.is_firing/15.0);
                jo_sprite_draw3D(weapon_id-1,0, 60+(yM>>1)+player.is_firing, 16);
                jo_sprite_restore_sprite_scale();
            }
            jo_sprite_disable_gouraud_shading();
            player.is_firing--;
        }
        else
        {
            if (player.weapon==0)
                jo_sprite_draw3D(weapon_id, 70, 80+(yM>>1), 15);
            else if (player.weapon==1)
                jo_sprite_draw3D(weapon_id+1,0, 90+(yM>>1), 15);
        }


        FIXED	pom[XYZ];

       // int PtX = player.x - (jo_cos_mult(draw_distance>>1, player.ry));
       // int PtZ = player.z - (jo_sin_mult(draw_distance>>1, player.ry));
        int PtX = player.x-900;
        int PtZ = player.z-900;
        jo_3d_push_matrix();
        {
            jo_3d_rotate_matrix(0, 0, -player.rz);
            jo_3d_rotate_matrix(0, player.ry, 0);
            jo_3d_translate_matrix(-player.x, -player.y - (player.crouchH>>2), -player.z);

            unsigned short i;
           // unsigned short ii;
            for (JO_ZERO(i);i<mesh_tot; i++)
            {
                if (jo_square_intersect((BSP_BB[i].MinValue.x), (BSP_BB[i].MinValue.z), (BSP_BB[i].LengthVal.x), (BSP_BB[i].LengthVal.z), PtX, PtZ, 1800, 1800))
                {
                    if (BSP_BB[i].MinValue.y - 500 <= player.y && BSP_BB[i].MinValue.y + BSP_BB[i].LengthVal.y + 500 >= player.y)
                    {
                        if (jo_square_intersect((BSP_BB[i].MinValue.x), (BSP_BB[i].MinValue.z), (BSP_BB[i].LengthVal.x), (BSP_BB[i].LengthVal.z), player.x-170, player.z-170, 340, 340) && BSP_BB[i].MinValue.y - 160 <= player.y && BSP_BB[i].MinValue.y + BSP_BB[i].LengthVal.y + 160 >= player.y)
                        {
                            slPutPolygon(&LevelMesh[i]->data);
                        }
                        else
                        {
                           // if (jo_square_intersect((BSP_BB[i].MinValue.x), (BSP_BB[i].MinValue.z), (BSP_BB[i].LengthVal.x), (BSP_BB[i].LengthVal.z), PtX-draw_distance>>1, PtZ-draw_distance>>1, draw_distance, draw_distance))// && BSP_BB[i].MinValue.y - 100 <= player.y && BSP_BB[i].MinValue.y + BSP_BB[i].LengthVal.y + 100 >= player.y)
                            //The SGL function slCheckOnScreen seems slow (do multiple checks for different points - 3 only in my tests - and it will slow down even on emulators), I'll probably create my own by simply looking at your axis and quickly determine what's impossible to be seen (like if you are looking toward X+, what's at X- can't be seen)

                            pom[X] = toFIXED(BSP_BB[i].MinValue.x + (BSP_BB[i].LengthVal.x>>1));
                            pom[Y] = toFIXED(BSP_BB[i].MinValue.y + (BSP_BB[i].LengthVal.y>>1));
                            pom[Z] = toFIXED(BSP_BB[i].MinValue.z + (BSP_BB[i].LengthVal.z>>1));
                            if(slCheckOnScreen(pom,toFIXED(750.0)) > 0)
                                slPutPolygon(&LevelMesh[i]->data);
                        }
                    }
                }
            }
            //draw_VDP2();
        }
        jo_3d_pop_matrix();

//jo_sprite_draw(0, (0, 80, 10), 0);
//jo_sprite_draw3D(0, 0, 120, 10);
if (TVstatus == false) {slTVOn(); TVstatus=true;}
jo_printf(0, 25, "Total quads :                      ");
jo_printf(0, 25, "Total quads : %d", jo_3d_get_polygon_count());
jo_printf(0, 26, "Disp quads :                  ");
jo_printf(0, 26, "Disp quads :  %d", jo_3d_get_displayed_polygon_count());
jo_printf(0, 27, "Vertices :                  ");
jo_printf(0, 27, "Vertices :    %d", jo_3d_get_vertices_count());
}



