/*********************
Most of the credit for this file goes to Danny (from Jo Engine forum).
Also to SEGA for the SGL demos!
**********************/

#include <jo/jo.h>

#include "backgrounds/fire.cel"
#include "backgrounds/fire.map"
#include "backgrounds/fire.pal"
/*#include	"backgrounds/sora5.cel"
#include	"backgrounds/sora5.map"
#include	"backgrounds/sora5.pal"*/
#include    "backgrounds/tuti2.map"
#include    "backgrounds/tuti2.cel"
#include    "backgrounds/tuti2.pal"



/*********************************
VDP2 VRAM ADRESSES, DON'T TOUCH UNLESS YOU KNOW WHAT YOU ARE DOING!
*******************************/
#define		RBG0RB_CEL_ADR			(VDP2_VRAM_A0            )
#define		RBG0RB_MAP_ADR			(VDP2_VRAM_B0            )
#define		RBG0RB_COL_ADR			(VDP2_COLRAM    + 0x00200)

#define		RBG0RA_CEL_ADR			(RBG0RB_CEL_ADR + 0x06e80)
#define		RBG0RA_MAP_ADR			(RBG0RB_MAP_ADR + 0x02000)
#define		RBG0RA_COL_ADR			(RBG0RB_COL_ADR + 0x00200)

#define		RBG0_KTB_ADR			(VDP2_VRAM_A1            )
#define		RBG0_PRA_ADR			(VDP2_VRAM_A1   + 0x1fe00)
#define		RBG0_PRB_ADR			(RBG0_PRA_ADR   + 0x00080)

#define		BACK_COL_ADR			(VDP2_VRAM_A1   + 0x1fffe)
#define		LINECOLOR			    (VDP2_VRAM_A0   + 0x04000)

//ADDED FROM THE SGL FIGHTING DEMO
#define		LINE_SCR_TABL		    (VDP2_VRAM_A0 + 0x1f000)
#define		LINE_COLOR_TABLE		(VDP2_VRAM_A0	+ 0x1f400)
#define		COLOR_RAM_ADR			(VDP2_COLRAM	+ 0x00600)
#define		CEL_LINE_TABLE			( VDP2_VRAM_B1 + 0x1f000)

#define		NBG2_CEL_ADR            (VDP2_VRAM_B1+0x02000)
#define		NBG2_MAP_ADR            (VDP2_VRAM_B1+0x18000)
#define		NBG2_COL_ADR            ( VDP2_COLRAM  + 0x00800 )



FIXED position[XYZ];
ANGLE angle[XYZ];
FIXED position_increment[XYZ];
ANGLE angle_increment;


static void init_globals()
{
	position[X] = toFIXED(500.0);
	position[Y] = toFIXED(400.0);
	position[Z] = toFIXED(110.0);

	angle[X] =  0x4008;//DEGtoANG(90.0);
	angle[Y] = DEGtoANG(0.0);
	angle[Z] = DEGtoANG(-90.0);

	/*position_increment[X] = toFIXED(0.0);
	position_increment[Y] = toFIXED(0.0);
	position_increment[Z] = toFIXED(0.0);
	angle_increment = DEGtoANG(0.0);*/

}

/*Copies the image cel data to VDP2 VRAM*/
void Cel2VRAM(const Uint8 *Cel_Data, void *Cell_Adr, Uint32 suu)
{
	Uint32 i;
	Uint8 *VRAM;

	VRAM = (Uint8 *) Cell_Adr;

	for (i = 0; i < suu; i++)
		*(VRAM++) = *(Cel_Data++);
}

/*Copies the image map data to VDP2 VRAM*/
void Map2VRAM(const Uint16 *Map_Data, void *Map_Adr, Uint16 suuj, Uint16 suui, Uint16 palnum, Uint32 mapoff)
{
	Uint16 i, j;
	Uint16 paloff;
	Uint16 *VRAM;

	paloff = palnum << 12;
	VRAM = (Uint16 *) Map_Adr;


	for (i = 0; i < suui; i++)
	{
		for (j = 0; j < suuj; j++)
		{
			*VRAM++ = (*Map_Data | paloff) + mapoff;
			Map_Data++;
		}
		VRAM += (64 - suuj);
	}
}

/*Copies the image palette data to CRAM*/
void Pal2CRAM(const Uint16 *Pal_Data, void *Col_Adr, Uint32 suu)
{
	Uint16 i;
	Uint16 *VRAM;

	VRAM = (Uint16 *) Col_Adr;

	for (i = 0; i < suu; i++)
		*(VRAM++) = *(Pal_Data++);
}

// line-by-line transfer to vram
/*void img2VRAM(Uint16 *vram, Uint16 vram_width, Uint16 *img, Uint16 img_height, Uint16 img_width)
{
    int i;
    Uint32 oVRAM = 0;
    Uint32 oIMG = 0;

    for(i = 0; i < img_height; i++)
        {
            memcpy((void *)(vram + oVRAM), (void *)(img + oIMG), img_width*sizeof(Uint16));
            oVRAM += vram_width;
            oIMG += img_width;
        }
}*/

void init_vdp2()
{
    /* -------------Imported from the SGL fighting demo------------------------- */
    //Uint16	*line_tt;
	//Sint32	aa; //,bx;
	//Uint16	*Line_Color_Pal0;

	slTVOff();
	slColRAMMode(CRM16_2048); //Mode 1 Color VRAM mode. 2048 colors can be used out of 32 768 (15 bits colors).
	//slColRAMMode(CRM32_1024); //Mode 2 allows special effects
/*------------------------------------------------------*/
/* Makes the background fade with the rotating plane. Currently buggy on real hardware	*/
/*------------------------------------------------------*/


	/*Line_Color_Pal0	=(Uint16 *)COLOR_RAM_ADR;
	for(aa = 0; aa < 240; aa++)
	{
		//Line_Color_Pal0[aa+32] = 32776;
		Line_Color_Pal0[aa] = 32776;
	}*/
/*	for(aa = 0; aa < 32; aa++)
	{
		Line_Color_Pal0[90-aa+32] = (aa << 10 | aa << 5 | aa | 32776);
		Line_Color_Pal0[91+aa-32] = (aa << 10 | aa << 5 | aa | 32776);
	}
	Line_Color_Pal0	=(Uint16 *)LINE_COLOR_TABLE;
	for(aa = 0; aa < 240; aa++)
	{
		Line_Color_Pal0[aa] = aa+256*3+32;
	}*/
	//slLineColDisp(NBG2ON);
	//slLineColTable((void *)LINE_COLOR_TABLE);
 	slColorCalc( CC_ADD | CC_TOP | NBG2ON | RBG0ON);
 	slColorCalcOn(RBG0ON | NBG2ON);
	//slColRateLNCL(0x1f);
    /* -------------------------END OF IMPORT ------------------------------ */



	slRparaInitSet((void *) RBG0_PRA_ADR); /* Rotation parameter table storage in VRAM */	/* This function stores in VRAM the rotation * parameter table (size: 60H) used for the rotating scroll. */
	slMakeKtable((void *) RBG0_KTB_ADR); /* Coefficient table creation */	/* This function creates at the specified address in VRAM * the coefficient table to be used for three-dimensional rotation. * ("adr" must be specified within the VDP2 RAM area.) */

	slCharRbg0(COL_TYPE_256, CHAR_SIZE_1x1); /* RBG character control setup */	/* This function sets the character size and the	 * number of colors used on rotating scroll RBG0. */
	slPageRbg0((void *) RBG0RB_CEL_ADR, 0, PNB_1WORD | CN_12BIT);	/* RBG pattern name data registration */
	/* This function sets up the rotating scroll RBG0 page. For the parameters, specify,
	 * respectively, the starting address (in VRAM) of the character pattern data used on
	 * the scroll screen, the starting address (in color RAM) for the color data used for the
	 * character patterns, and a Uint16-type value corresponding to the pattern name
	 * data-type specification. */


	slPlaneRA(PL_SIZE_1x1);		/* RBG plane size setting (for rotation parameters A) *//*This function sets the plane size for rotating scrolls	 * (using rotation parameters A).*/
	sl1MapRA((void *) RBG0RA_MAP_ADR);  /* RGB map setup (using rotation parameters A) */ /* This function sets up the rotating scroll map (using rotation parameters A). For the 	 * parameter, substitute the starting address in VRAM of the pattern name data table * to be registered in the map register and the map offset register. The data table 	 * uses 16 pages, starting from the specified address. */
	slOverRA(0);  /* RBG screen overflow processing setting (for rotation parameters A) */ /* This function sets the screen overflow processing mode for the rotating scroll. The * screen overflow processing setting specifies how, when the rotating scroll graphics * go beyond the display area, to process the portion that exceeds the display area. * This setting is made for the rotating scroll plane size register. * 0: Outside of the display area, repeat image set in the display area* 1: Outside of the display area, repeat the specified character pattern* 2: Outside of the display area, leave entire area clear* 3: Outside of the 512 (vertical) x 512 (horizontal) display area, leave everything clear. */
	slKtableRA((void *) RBG0_KTB_ADR, K_FIX | K_DOT | K_2WORD | K_ON | K_LINECOL);	/*------Coefficient table control settings---------*/	/* This function sets the coefficient table address * in VRAM in a register and also specifies how the * coefficient table is to be used and its configuration. */

	Cel2VRAM(tuti_cel, (void *) RBG0RA_CEL_ADR, 65536);
	Map2VRAM(tuti_map, (void *) RBG0RA_MAP_ADR, 64, 64, 2, 884);
 	Pal2CRAM(tuti_pal, (void *) RBG0RA_COL_ADR, 160);

	/* RBG plane size setting (for rotation parameters B) */
	//slPlaneRB(PL_SIZE_1x1);
	/* Same as slPlaneRA*/

	/* RGB map setup (using rotation parameters B) */
	//sl1MapRB((void *) RBG0RB_MAP_ADR);
	/* Same as sl1MapRA*/

	/* RBG screen overflow processing setting (for rotation parameters B) */
//	slOverRB(0);
	/* Same as slOverRA*/

	/* Coefficient table control settings */
//	slKtableRB((void *) RBG0_KTB_ADR, K_FIX | K_DOT | K_2WORD | K_ON | K_LINECOL);
	/* This function sets the coefficient table address in VRAM in a register and also
	 * specifies how the coefficient table is to be used and its configuration.*/

//	Cel2VRAM(sora_cel, (void *) RBG0RB_CEL_ADR, 28288);
//	Map2VRAM(sora_map, (void *) RBG0RB_MAP_ADR, 64, 20, 1, 0);
//	Pal2CRAM(sora_pal, (void *) RBG0RB_COL_ADR, 256);

/*------------------------------------------------------*/  //Rotating plane background using parameter B,
/*	slPlaneRB(PL_SIZE_1x1);
	sl1MapRB((void *)RBG0RB_MAP_ADR);
	slOverRB(0);
	slKtableRB((void *)RBG0_KTB_ADR , K_FIX | K_DOT | K_2WORD | K_ON );
	Cel2VRAM(sora5_cel , (void *)RBG0RB_CEL_ADR , 28288);
	Map2VRAM(sora5_map , (void *)RBG0RB_MAP_ADR , 64 , 64 , 1 , 0);
	Pal2CRAM(sora5_pal , (void *)RBG0RB_COL_ADR , 256);*/
/*------------------------------------------------------*/
	/*------------------------------------------------------*/
	slCharNbg2(COL_TYPE_256 , CHAR_SIZE_2x2);
	slPageNbg2((void *)NBG2_CEL_ADR , 0 , PNB_1WORD|CN_10BIT);
    slPlaneNbg2(PL_SIZE_1x1);
    slMapNbg2((void *)NBG2_MAP_ADR , (void *)NBG2_MAP_ADR , (void *)NBG2_MAP_ADR , (void *)NBG2_MAP_ADR);

    Cel2VRAM(cel_fire, (void*)NBG2_CEL_ADR, sizeof(cel_fire)/sizeof(char));
    Map2VRAM(map_fire, (void*)NBG2_MAP_ADR, 64, 16, 4, 64);
    Pal2CRAM(pal_fire, (void*)NBG2_COL_ADR, sizeof(pal_fire)/sizeof(Uint16));
    /*Cel2VRAM(sora5_cel , (void *)NBG2_CEL_ADR , 28288) ;
    Map2VRAM(sora5_map , (void *)NBG2_MAP_ADR , 64 , 64 , 4 ,256) ;
    Pal2CRAM(sora5_pal , (void *)NBG2_COL_ADR , 256) ;*/
/*------------------------------------------------------*/
	/* Rotation parameter mode setting */
	slRparaMode(RA);
	/* This function specifies the rotation parameter mode. This function makes it
	 * possible to specify how rotation parameters A and B are used.
	 * Modes:
	 * RA: Use only rotation parameters A.	 * RB: Use only rotation parameters B. 	 * K_CHANGE: Change screens according to the coefficient data of rotation parameters A * W_CHANGE: Change screens according to the rotation parameter window.*/
	/* Background screen single-color setup */
slBack1ColSet((void *) BACK_COL_ADR, JO_COLOR_Black);
	/* This function sets up the background screen.
	 * The "background screen" is the graphics screen that is displayed in the
	 * background in those areas where absolutely nothing else is displayed.*/

	/* Scroll registration (cycle pattern register setting) */
	//slScrAutoDisp(NBG0ON | RBG0ON);
	/* This function registers in the system those scrolls for which the function settings
	 * have been completed. This function automatically sets the VRAM access
	 * specification (in the cycle pattern register) for the scroll screen specified as the
	 * parameter, and at the same time turns on the graphics setting for the registered scroll. */
	slScrLineWindow0((void *)(LINE_SCR_TABL | 0x80000000));
	slScrWindowMode(scnROT,win0_IN);		/* No idea what it's for ATM */

	//slColRAMOffsetRbg0(64); //You can play with palettes offsets to change the colour of the background without swapping images. Example : You want the screen to fade to black, or you want to display "lightning" by making the BG white...
    slScrTransparent(NBG2ON | RBG0ON);  //Transparency, I don't know much about it yet

	slScrAutoDisp(NBG0ON | NBG2ON | RBG0ON); //If you want the image to keep scrolling (warp around) when you move it.




	slTVOn();  //Display the screen

	/************
	VERY IMPORTANT : If you want to use a NBG2 layer as foreground (or any layer), you need to change the priority. Priority 7 = NBG0, Priority 6 = sprites/polygons.
	so switch all the priorities depending on the results you want. If you use a NBG2 layer for the weapons in a FPS, you will want a higher priority (6), but still
	keep NBG0 as priority 7 since you want your HUD to be always displayed.
	Also, the RBG0 3d plane set as higher priority will just hide everything, so it's tricky to use it as a floor mixed with polygons.
	*************/
	 //slPriorityNbg1(6); //Same priority as sprites
	// slPrioritySp
}


void draw_VDP2()
{


	slPushMatrix();
	{
	    slTranslate(position[X] - toFIXED(160), position[Y], position[Z]);
		slRotX(DEGtoANG(-90.0));
		slCurRpara(RA);
		slScrMatConv();
		slScrMatSet();
	}
	slPopMatrix();


/*  If you want to use the RBG0 Parameter B...
	slPushMatrix();
	{
		//slTranslate(toFIXED(160.0)+(angle[Z] << 10), toFIXED(154.0) - 112 * slCos(angle[X]), toFIXED(100.0));
        slRotX(DEGtoANG(-90.0));
		slCurRpara(RB);
		slScrMatConv();
		slScrMatSet();
	}
	slPopMatrix();*/

}

void draw_VDP2_background(int BGxIncrease, int BGyIncrease)
{
    static int bg_x;
    static short yScrolling = 0;
    static char xScrolling = 0; static bool xScrollingDirection=false;
    bg_x += BGxIncrease;

    yScrolling+=6;
    if (yScrolling>=1024)yScrolling-=1024;

    if (xScrollingDirection==false)
        xScrolling++;
    else xScrolling--;
    if (xScrolling==64) xScrollingDirection=true;
    else if (xScrolling==0) xScrollingDirection=false;
/* If you want to rotate it, just rotate with the increments you make to the rotation of the screen, not the angle itself, else it will rotate like crazy! */
    slScrPosNbg2(toFIXED(bg_x) + toFIXED(xScrolling>>1), toFIXED(40) + toFIXED(BGyIncrease)+ toFIXED(yScrolling));

}

void initialize_VDP2(void)
{
    init_vdp2();
    init_globals();
}

